/*
 * Copyright 2005-2009 WSO2, Inc. http://wso2.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

function addNewTab() {


    showInputWizard(jsi18n["what.should.be.tab.name"], addNewTabNextHandler, addNewTabCancelHandler);

}
function addNewTabUnsignedUser() {
showInputDialog(jsi18n["what.should.be.tab.name"], addNewTabOkHandler, addNewTabCancelHandler);
}


function addNewTabCancelHandler() {
    return true;
}

function addNewTabNextHandler(tabTitle) {
    // Obtain a name for this new Tab
    if (tabTitle == null || tabTitle == "") {
        CARBON.showErrorDialog(jsi18n["no.tab.name"]);
        return;
    }

    var resp = UserPrefsService.addNewTab(userId, tabTitle, dashboardName);

    if (resp == 0) {
        CARBON.showErrorDialog(jsi18n["same.tab.name"]);
    }

    if (tabTitle == "") {
        tabTitle = "Tab " + resp;
    }


    if (resp) {
        // Deactivate all tabs
        var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
        for (var x = 0; x < tabLinks.length; x++) {
            tabLinks[x].className = "";
        }

        // Create a new tab
        var tabMenu = document.getElementById("tabmenu");
        tabMenu.innerHTML =
        tabMenu.innerHTML + '<li onclick="makeActiveTab(' + resp + ')"><a class="" id="tab' + resp +
        '">' + tabTitle + '</a></li>';

        // Clear existing tab content
        document.getElementById("tabContent").innerHTML = ""

        // Updating the global pointer
        currentActiveTab = resp;


        // Making the new tab active
        makeActiveTab(currentActiveTab);


        jQuery("#newLayoutsPane").show("slow");




    }
}
function addNewTabOkHandler(tabTitle) {
    // Obtain a name for this new Tab
    if (tabTitle == null || tabTitle == "") {
        CARBON.showErrorDialog(jsi18n["no.tab.name"]);
        return;
    }

    var resp = UserPrefsService.addNewTab(userId, tabTitle, dashboardName);

    if (resp == 0) {
        CARBON.showErrorDialog(jsi18n["same.tab.name"]);
    }

    if (tabTitle == "") {
        tabTitle = "Tab " + resp;
    }


    if (resp) {
        // Deactivate all tabs
        var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
        for (var x = 0; x < tabLinks.length; x++) {
            tabLinks[x].className = "";
        }

        // Create a new tab
        var tabMenu = document.getElementById("tabmenu");
        tabMenu.innerHTML =
        tabMenu.innerHTML + '<li onclick="makeActiveTab(' + resp + ')"><a class="" id="tab' + resp +
        '">' + tabTitle + '</a></li>';

        // Clear existing tab content
        document.getElementById("tabContent").innerHTML = ""

        // Updating the global pointer
        currentActiveTab = resp;


        // Making the new tab active
        makeActiveTab(currentActiveTab);

    }
}



function duplicateActiveTab() {
    showInputDialog(jsi18n["what.should.be.tab.name"], duplicateActiveTabOkHandler, duplicateActiveTabCancelHandler);
}

function duplicateActiveTabOkHandler(tabTitle) {
    // Obtain a name for this new Tab
    if (tabTitle == null || tabTitle == "") {
        CARBON.showErrorDialog(jsi18n["no.tab.name"]);
        return;
    }

    var resp = UserPrefsService.duplicateTab(userId, dashboardName, currentActiveTab, tabTitle);

    if (resp == 0) {
        CARBON.showErrorDialog(jsi18n["same.tab.name"]);
    }

    if (tabTitle == "") {
        tabTitle = "Tab " + resp;
    }

    if (resp) {
        // Deactivate all tabs
        var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
        for (var x = 0; x < tabLinks.length; x++) {
            tabLinks[x].className = "";
        }

        // Create a new tab
        var tabMenu = document.getElementById("tabmenu");
        tabMenu.innerHTML =
        tabMenu.innerHTML + '<li onclick="makeActive(' + resp + ')"><a class="" id="tab' + resp +
        '">' + tabTitle + '</a></li>';

        // Clear existing tab content
        document.getElementById("tabContent").innerHTML = ""

        // Updating the global pointer
        currentActiveTab = resp;

        // Making the new tab active
        makeActive(currentActiveTab);

    }
}

function duplicateActiveTabCancelHandler() {
    return true;
}

function makeActiveTab(tabId) {

    var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
    for (var x = 0; x < tabLinks.length; x++) {
        tabLinks[x].className = "";
    }

    document.getElementById("tab" + tabId).className = "active";

    // Clear existing tab content
    document.getElementById("tabContent").innerHTML = ""
    document.getElementById("tabContent").style.display = ""

    document.getElementById("maximizedGadget").innerHTML = ""
    document.getElementById("maximizedGadget").style.display = "none"

    // Updating the global pointer
    currentActiveTab = tabId;


}
function makeActive(tabId)
{var tabLinks = document.getElementById("tabmenu").getElementsByTagName("a");
    for (var x = 0; x < tabLinks.length; x++) {
        tabLinks[x].className = "";
    }

    document.getElementById("tab" + tabId).className = "active";

    // Clear existing tab content
    document.getElementById("tabContent").innerHTML = ""
    document.getElementById("tabContent").style.display = ""

    document.getElementById("maximizedGadget").innerHTML = ""
    document.getElementById("maximizedGadget").style.display = "none"

    // Updating the global pointer
    currentActiveTab = tabId;
// Set the container view to default
    gadgets.container.setView("default");

    // Load gadgets for the active tab
    renderLayout();

    // Initialise the container
    gadgetserver.init();
    gadgetserver.renderGadgets();

    $(".connect").sortable({
        connectWith: ['.connect'],
        opacity: 0.7,
        revert: true,
        scroll: true,
        delay: 250,
        placeholder: 'block-hover',
        tolerance: 'pointer',
        update: function(event, ui) {
            persistLayout();

        }
    });

    //drawOptionsButton();
}

function removeActiveTab() {
    confirmDialog(jsi18n["remove.tab"], removeActiveTabAction, currentActiveTab)
}

function removeActiveTabAction(tabId) {
    if (currentActiveTab == 0) {
        CARBON.showErrorDialog(jsi18n["cannot.delete.tab"]);
    } else {
        var resp = UserPrefsService.removeTab(userId, currentActiveTab, dashboardName);

        if (resp) {
            // Refresh page
            window.location = 'index.jsp?name=' + dashboardName;
        } else {
            CARBON.showErrorDialog(jsi18n["failed.removing.active.tab"]);
        }
    }
}

//Call the method which will change the layout of a tab.
function setLayout(layout) {

    UserPrefsService.populateCustomLayouts(userId, currentActiveTab, layout);

    jQuery("#newLayoutsPane").hide("slow");


}

