var UserPrefsService = UserPrefsService || {};

UserPrefsService.addGadget =
function addGadget(userId, tabId, url, dashboardName, group) {
    if (checkSession()) {
        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=addGadget&userId=" + userId + "&tabId=" + tabId + "&url=" + url +
                  "&dashboardName=" + dashboardName + "&group=" + group + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return response == "true" || response == "1";
    }
}


UserPrefsService.addNewTab =
function addNewTab(userId, tabTitle, dashboardName)
{
    if (checkSession()) {
        if (UserPrefsService.hasTabName(userId, tabTitle, dashboardName)) {
            return 0;
        }

        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=addNewTab&userId=" + userId + "&tabTitle=" + tabTitle + "&dashboardName=" +
                  dashboardName + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return parseInt(response);
    }
}


UserPrefsService.getGadgetLayout =
function getGadgetLayout(userId, tabId, dashboardName)
{

    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=getGadgetLayout&userId=" + userId + "&tabId=" + tabId + "&dashboardName=" +
              dashboardName + "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    if (response == "") {
        response = "NA";
    }
    return response;
}


UserPrefsService.getGadgetPrefs =
function getGadgetPrefs(userId, gadgetId, prefId, dashboardName)
{

    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=getGadgetPrefs&userId=" + userId + "&gadgetId=" + gadgetId + "&prefId=" +
              prefId + "&dashboardName=" + dashboardName + "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response;

}


UserPrefsService.getGadgetUrlsToLayout =
function getGadgetUrlsToLayout(userId, tabId, dashboardName)
{
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=getGadgetUrlsToLayout&userId=" + userId + "&tabId=" + tabId +
              "&dashboardName=" + dashboardName + "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response.split(",");
}


UserPrefsService.getTabLayout =
function getTabLayout(userId, dashboardName)
{
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=getTabLayout&userId=" + userId + "&dashboardName=" + dashboardName +
              "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response;
}


UserPrefsService.getTabTitle =
function getTabTitle(userId, tabId, dashboardName)
{
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=getTabTitle&userId=" + userId + "&tabId=" + tabId +
              "&dashboardName=" +
              dashboardName + "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response;
}


UserPrefsService.isReadOnlyMode =
function isReadOnlyMode(userId)
{
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=isReadOnlyMode&userId=" + userId + "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response == "true" || response == "1";
}


UserPrefsService.removeGadget =
function removeGadget(userId, tabId, gadgetId, dashboardName)
{
    if (checkSession()) {
        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=removeGadget&userId=" + userId + "&tabId=" + tabId +
                  "&dashboardName=" +
                  dashboardName + "&gadgetId=" + gadgetId + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return response == "true" || response == "1";
    }
}


UserPrefsService.removeTab =
function removeTab(userId, tabId, dashboardName)
{
    if (checkSession()) {
        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=removeTab&userId=" + userId + "&tabId=" + tabId +
                  "&dashboardName=" +
                  dashboardName + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return response == "true" || response == "1";
    }
}


UserPrefsService.setGadgetLayout =
function setGadgetLayout(userId, tabId, newLayout, dashboardName)
{
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=setGadgetLayout&userId=" + userId + "&tabId=" + tabId +
              "&dashboardName=" +
              dashboardName + "&newLayout=" + newLayout + "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response == "true" || response == "1";
}

UserPrefsService.setGadgetPrefs =
function setGadgetPrefs(userId, gadgetId, prefId, value, dashboardName)
{
    var val = encodeHex(value);
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=setGadgetPrefs&userId=" + userId + "&gadgetId=" + gadgetId + "&prefId=" +
              prefId + "&value=" + val + "&dashboardName=" + dashboardName + "&nocache=" +
              new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response == "true" || response == "1";
}


UserPrefsService.duplicateTab = function duplicateTab(userId, dashboardName, sourceTabId, newTabName)
{
    if (checkSession()) {
        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=duplicateTab&userId=" + userId + "&dashboardName=" + dashboardName + "&sourceTabId=" +
                  sourceTabId + "&newTabName=" + newTabName + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return parseInt(response);
    }
}

UserPrefsService.copyGadget = function copyGadget(userId, tab, dashboardName, sourceGadgetId) {
    if (checkSession()) {
        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=copyGadget&userId=" + userId + "&dashboardName=" + dashboardName + "&sourceGadgetId=" +
                  sourceGadgetId + "&tab=" + tab + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return response == "true" || response == "1";
    }
}

UserPrefsService.moveGadgetToTab = function moveGadgetToTab(userId, tab, dashboardName, sourceGadgetId) {
    if (checkSession()) {
        var response = jQuery.ajax({
            type: "POST",
            url: "UserPrefsServiceClient-ajaxprocessor.jsp",
            data: "func=moveGadget&userId=" + userId + "&dashboardName=" + dashboardName + "&sourceGadgetId=" +
                  sourceGadgetId + "&tab=" + tab + "&nocache=" + new Date().getTime(),
            async:   false
        }).responseText;

        response = removeCarriageReturns(response);
        return response == "true" || response == "1";
    }
}

UserPrefsService.hasTabName = function hasTabName(userId, tabName, dashboardName) {

    //takeing the gadget url from cookie
    var tabIds = UserPrefsService.getTabLayout(userId, dashboardName).split(',');
    for (var x = 0; x < tabIds.length; x++) {
        var tabTitle = UserPrefsService.getTabTitle(userId, tabIds[x], dashboardName);
        if (tabName == tabTitle) {
            return true;
        }
    }
    return false;
}

//This method is not valid for a logged in user
UserPrefsService.isNewUser = function isNewUser() {
    return true;
}

UserPrefsService.isValidTab = function isValidTab(userId, currentActiveTab, dashboardName) {
    var title = UserPrefsService.getTabTitle(userId, currentActiveTab, dashboardName);
    if (title == 'null') {
        return false;
    }

    return true;
}

UserPrefsService.populateDefaultThreeColumnLayout = function populateDefaultThreeColumnLayout(userId, tabId) {
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=populateDefaultThreeColumnLayout&userId=" + userId + "&tabId=" + tabId +
              "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response;
}
UserPrefsService.populateCustomLayouts = function populateCustomLayouts(userId, tabId,layout) {
    var response = jQuery.ajax({
        type: "POST",
        url: "UserPrefsServiceClient-ajaxprocessor.jsp",
        data: "func=populateCustomLayouts&userId=" + userId + "&tabId=" + tabId +"&layout=" + layout +
              "&nocache=" + new Date().getTime(),
        async:   false
    }).responseText;

    response = removeCarriageReturns(response);
    return response;
}